#!/usr/bin/env python

import sys
from rios import rat
import numpy
import osgeo.gdal as gdal


#Input file.
fname = "L7ETM_530N035W_Classification.kea"
ratDataset = gdal.Open( fname, gdal.GA_Update )

print("Import Columns.")
MayBlue = rat.readColumn(ratDataset, "MayBlue")
MayGreen = rat.readColumn(ratDataset, "MayGreen")
MayRed = rat.readColumn(ratDataset, "MayRed")
MayNIR = rat.readColumn(ratDataset, "MayNIR")
MaySWIR1 = rat.readColumn(ratDataset, "MaySWIR1")
MaySWIR2 = rat.readColumn(ratDataset, "MaySWIR2")

JuneBlue = rat.readColumn(ratDataset, "JuneBlue")
JuneGreen = rat.readColumn(ratDataset, "JuneGreen")
JuneRed = rat.readColumn(ratDataset, "JuneRed")
JuneNIR = rat.readColumn(ratDataset, "JuneNIR")
JuneSWIR1 = rat.readColumn(ratDataset, "JuneSWIR1")
JuneSWIR2 = rat.readColumn(ratDataset, "JuneSWIR2")

MeanDEM = rat.readColumn(ratDataset, "MeanDEM")

MayNIR.astype(numpy.float32)
MayRed.astype(numpy.float32)
JuneNIR.astype(numpy.float32)
JuneRed.astype(numpy.float32)
MayBlue.astype(numpy.float32)
JuneBlue.astype(numpy.float32)

print("Calculate Indices.")
MayNDVI = (MayNIR - MayRed) / (MayNIR + MayRed)
JuneNDVI = (JuneNIR - JuneRed) / (JuneNIR + JuneRed)

MayWBI = MayBlue/MayNIR
JuneWBI = JuneBlue/JuneNIR

rat.writeColumn(ratDataset, "MayNDVI", MayNDVI)
rat.writeColumn(ratDataset, "JuneNDVI", JuneNDVI)
rat.writeColumn(ratDataset, "MayWBI", MayWBI)
rat.writeColumn(ratDataset, "JuneWBI", JuneWBI)
