#! /usr/bin/env python

#######################################
# A class that iterates through a directory
# or directory structure and prints out theatre
# identified files.
# Author: <YOUR NAME>
# Email: <YOUR EMAIL>
# Date: DD/MM/YYYY
# Version: 1.0
#######################################

import os.path
import sys

class IterateFiles (object):
    
    # A function which checks a file extension and returns 
    def checkFileExtension(self, filename, extension):
        # Boolean variable to be returned by the function
        foundExtension = False;
        # Split the filename into two parts (name + ext)
        filenamesplit = os.path.splitext(filename)
        # Get the file extension into a varaiable
        fileExtension = filenamesplit[1].strip()
        # Decide whether extensions are equal
        if(fileExtension == extension):
            foundExtension = True
        # Return result
        return foundExtension
            
    # A function which iterates through the directory and checks file extensions       
    def findFilesExtRecurse(self, directory, extension):
        # check whether the current directory exits
        if os.path.exists(directory):
            # check whether the given directory is a directory
            if os.path.isdir(directory):
                # list all the files within the directory
                dirFileList = os.listdir(directory)
                # Loop through the individual files within the directory
                for filename in dirFileList:
                    # Check whether file is directory or file
                    if(os.path.isdir(os.path.join(directory,filename))):
                        # If a directory is found recall this function.
                        self.findFilesRecurse(os.path.join(directory,filename))
                    elif(os.path.isfile(os.path.join(directory,filename))):
                        if(self.checkFileExtension(filename, extension)):
                            print(os.path.join(directory,filename))
                    else:
                        print(filename + ' is NOT a file or directory!')
            else:
                print(directory + ' is not a directory!')
        else:
            print(directory + ' does not exist!')
    
    
    # A function which iterates through the directory and checks file extensions
    def findFilesExt(self, directory, extension):
        # check whether the current directory exits
        if os.path.exists(directory):
            # check whether the given directory is a directory
            if os.path.isdir(directory):
                # list all the files within the directory
                dirFileList = os.listdir(directory)
                # Loop through the individual files within the directory
                for filename in dirFileList:
                    # Check whether file is directory or file
                    if(os.path.isdir(os.path.join(directory,filename))):
                        print(os.path.join(directory,filename) + \
                        ' is a directory and therefore ignored!')
                    elif(os.path.isfile(os.path.join(directory,filename))):
                        if(self.checkFileExtension(filename, extension)):
                            print(os.path.join(directory,filename))
                    else:
                        print(filename + ' is NOT a file or directory!')
            else:
                print(directory + ' is not a directory!')
        else:
            print(directory + ' does not exist!')
    
    def run(self):
        # Set the folder to search
        searchFolder = './PythonCourse' # Update path...
        self.findFilesExt(searchFolder, '.txt')

if __name__ == '__main__':
    obj = IterateFiles()
    obj.run()